/*  www.sgm.siedlce.pl

test detekcji 1 kanalu odbiornika RC
w oparciu o przerwanie;
obsługa przerwania --> procedury
void pulse_rising()
void pulse_falling()

pomiar czasu --> porownanie standardowej funkcji micros()
z funkcja dokladnego (do 0,5us) pomiaru
przy uzyciu biblioteki:

===================================================================================================
<eRCaGuy_Timer2_Counter.h> by Gabriel Staples
Visit my blog at http://electricrcaircraftguy.blogspot.com/
-My contact info is available by clicking the "Contact Me" tab at the top of my blog.
-Please support my work & contributions by buying something here: https://sites.google.com/site/ercaguystore1/
My original post containing this code can be found here: http://electricrcaircraftguy.blogspot.com/2014/02/Timer2Counter-more-precise-Arduino-micros-function.html
Written: 17 May 2014
Updated: 30 May 2014
===================================================================================================
  LICENSE & DISCLAIMER
  Copyright (C) 2015 Gabriel Staples.  All right reserved.
  
  ------------------------------------------------------------------------------------------------
  License: GNU Lesser General Public License Version 3 (LGPLv3) or later - https://www.gnu.org/licenses/lgpl.html
  ------------------------------------------------------------------------------------------------

  This file is part of eRCaGuy_Timer2_Counter.
  
  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program.  If not, see http://www.gnu.org/licenses/
===================================================================================================
*/

//dolaczenie biblioteki
#include <eRCaGuy_Timer2_Counter.h>

// funkcja timer2.get_count()  podaje wynik w jednostkach 0.5us
// funkcja timer2.get_micros() podaje wynik w mikrosekundach

//deklaracje zmiennych

volatile int pulse1_start = 0;   //zmienne dla micros()
int pulse1_micros = 0;           //zmienna na dlugosc impulsu
                                 //kanalowego PPM wg micros()

float pulse1_start2 = 0;         //zmienna dla get_micros() 
float pulse1_getm = 0;           //zmienna na dlugosc impulsu                                
                                 //kanalowego PPM wg get_micros()
                                 
float diff = 0;                  //zmienna na roznice pomiarow               

//inicjalizacja programu
  
void setup() {
  //obowiazkowa inicjalizacja Timer2 wymagana przez
  //biblioteke <eRCaGuy_Timer2_Counter.h>
  timer2.setup(); 
  
  //inicjalizacja portu szeregowego (prezentacja danych)
  Serial.begin(115200); 
  //inicjalizacja przerwania 0 (pin 2, Arduino UNO)
  attachInterrupt(0, pulse_rising, RISING);  
}

//glowna petla programu

void loop() {
  // tutaj program uzytkowy, bazujacy na zmierzonym
  // czasie trwania impulsu kanlaowego PPM
  
  
  //obsulga zmiennych do drukowania pomiaru na port szeregowy 
  static unsigned long t_start = millis();
  unsigned long t_print_count = millis(); 
  
  //jesli uplynelo 500msec to drukuj
  if ((t_print_count - t_start) >= 500) 
  {
    t_start = t_print_count;
    //drukuj wartosc wg micros()
    Serial.print("micros() pulse1 = "); Serial.print(pulse1_micros);
    //drukuj wartosc wg get_micros()
    Serial.print(";    get_micros() pulse1 = "); Serial.print(pulse1_getm);
    Serial.print(";    diff = "); Serial.println(diff);
  }

} // koniec glownej petli



// obsluga przerwania (rising)
void pulse_rising() {
  attachInterrupt(0, pulse_falling, FALLING);
  pulse1_start = micros();
  pulse1_start2 = timer2.get_micros();
}

// obsluga przerwania (falling) 
void pulse_falling() {
  attachInterrupt(0, pulse_rising, RISING);
  //dlugosc impulsu wg micros()
  pulse1_micros = micros()-pulse1_start;
  //dlugosc impulsu wg get_micros()
  pulse1_getm = timer2.get_micros()-pulse1_start2;
  //roznica
  diff = pulse1_getm - pulse1_micros;
}





